/*
 *  EXPANDM.C	    expands alias via uulib:Aliases and prints
 *		    results
 *
 *  (C) Copyright 1989-1990 by Matthew Dillon,	All Rights Reserved.
 *
 *  EXPANDM alias
 */

#include <exec/types.h>
#include <exec/libraries.h>
#include <stdlib.h>
#include <stdio.h>
#include "config.h"
#include "version.h"
#include <owndevunit.h>

IDENT (".02");

void myexit (void);
int callBack (const char *, long, int);

struct Library
	*OwnDevUnitBase = NULL;

int
main (int ac, char **av)
{
	short
		i;
	int
		r;

	atexit (myexit);

	if ((OwnDevUnitBase = OpenLibrary ((UBYTE *) ODU_NAME, 0)) == NULL) {
		fprintf (stderr, "Unable to open %s\n", ODU_NAME);
		exit (30);
	}

	LoadAliases ();
	for (i = 1; i < ac; ++i) {
		printf ("%s:\n", av [i]);
		r = UserAliasList (av [i], callBack, 0L, 1);
#ifdef NOTDEF
		if (r)
		    printf ("alias error %ld\n", r);
#endif
	}

	exit (0);
}

void
myexit (void)
{
	UnLockFiles ();

	if (OwnDevUnitBase) {
		CloseLibrary (OwnDevUnitBase);
		OwnDevUnitBase = NULL;
	}

	return;
}

int
callBack (const char *name, long dummy, int show)
{
	printf ("    ");

	switch (name [0]) {
		case '|':
			printf ("(piped to program)       ");
			break;
		case '>':
			printf ("(appended to file)       ");
			break;
		case '<':
			printf ("(further aliases)        ");
			break;
		case '\\':
			++name;
			/* FALLTHROUGH */
		default:
			if (show < 0)
				printf ("(on To: field only)      ");
			else
				if (show == 0)
					printf ("(not shown on To: field) ");
				else
					printf ("(shown on To: field)     ");
			break;
	}

	printf (": %s\n", name);

	return 0;
}
